#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Images\Buchsammlung.ico
#AutoIt3Wrapper_Outfile=Reader.exe
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.10.2
 Author:         Kanashius
 Rights:		 Alle Rechte sind der Person hinter dem Nickname Kanashius im Autoit.de Forum vorbehalten.
				 Die Verbreitung ist kommerziell verboten und darf nur kostenlos erfolgen.
				 Das Programm und der Quelltext drfen auch nur solange verbreitet werden, wie der Autor es erlaubt.
				 Der Quelltext darf (in Ausschnitten und als Ganzes) nur mit Nennung des Autors verbreitet werden.
 Script Function:
				 Programm um E-Pubs zu lesen. Inklusive Vorlesefunktion.

#ce ----------------------------------------------------------------------------

#include <array.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <File.au3>
#include <String.au3>
#include <IE.au3>
;#include "_XMLDomWrapper.au3"
#include <GuiListBox.au3>
#include <GuiScrollBars.au3>
#include <GuiComboBoxEx.au3>
#include <GuiSlider.au3>
Opt("GUIOnEventMode", 1)
OnAutoItExitRegister("_saveAktState")

global $settingsIniPfad =@ScriptDir&"\Data\Settings\settings.ini"
global $LanguageSettingsIniPath = @ScriptDir&"\Data\Settings\language.ini"
$globalLanguage=IniRead($settingsIniPfad,"General","language",-1)
if $globalLanguage=-1 then
	$nr=StringRight(@OSLang, 2)
	if $nr="07" then
		$globalLanguage="Deutsch"
	elseif $nr="09" then
		$globalLanguage="English"
	else
		msgbox(48,"Hint","Sorry, your language is not supported. English had been choosen as default!")
		$globalLanguage="English"
	endif
	IniWrite($settingsIniPfad,"General","language",$globalLanguage)
endif

global $ReadGui,$ReadObj,$IE,$GlobalReadPath,$ReadObj2,$IE2,$ReadGui_Edit,$ButtonNext,$ButtonPrev,$pos=0,$ComboVoice,$ButtonPause,$ButtonStop,$VolumeSlider,$RateSlider,$ComboOutput,$ReadEdit,$ComboSize,$CheckBoxSavePosition,$actSize=12,$LanguageCombo
global $spinesar[1],$manifestsar[1][3]
global $o_doc,$FileName="",$StateIni=@ScriptDir&"\Data\Settings\FilesStates.ini"
global $ges[1][1],$Epubpath=""
global $oTalk = ObjCreate('SAPI.SpVoice'),$VoiceBreak=false,$speaking=false,$ReadModeEdit=false
global $guiInfo[5]

if $CmdLine[0]>0 then; Anzahl der Parameter
	$Epubpath=$CmdLine[1]; 1. Parameter
	if StringInStr($Epubpath,"%20%") then
		$Epubpath=StringReplace($Epubpath,"%20%"," ")
	endif
endif

If FileExists($settingsIniPfad)=0 Then
	;settings.ini erstellen
	$settingsFile=FileOpen($settingsIniPfad)
	$string="PosX=0"&@LF&"PosY=0"&@LF&"Width="&800&@LF&"Height="&600-20&@LF&"State=47"&@LF&"Font-Size=14"
	IniWriteSection($settingsIniPfad,"ReaderGuiSettings",$string)
	FileClose($settingsFile)
EndIf

$guiInfo[0]=IniRead($settingsIniPfad,"ReaderGuiSettings","PosX","0")
$guiInfo[1]=IniRead($settingsIniPfad,"ReaderGuiSettings","PosY","0")
$guiInfo[2]=IniRead($settingsIniPfad,"ReaderGuiSettings","Width",800)
$guiInfo[3]=IniRead($settingsIniPfad,"ReaderGuiSettings","Height",600-20)
$guiInfo[4]=IniRead($settingsIniPfad,"ReaderGuiSettings","State","47")
$SaveFilePos=IniRead($settingsIniPfad,"ReaderSettings","SaveFilesPos",true)
$actSize=IniRead($settingsIniPfad,"ReaderGuiSettings","Font-Size","14")
Reader()
if $Epubpath="" then
	$Epubpath=FileOpenDialog(_getLanguageText("chooseEpub"),@DesktopDir,"epub (*.epub)",1,"",$ReadGui)
endif
_setData($Epubpath)

aktCombos()

GUISetOnEvent($GUI_EVENT_CLOSE, "MainGui_Close")

GUIRegisterMsg($WM_COMMAND, "WM_COMMAND")
GUIRegisterMsg($WM_VSCROLL, "WM_SCROLL")
GUIRegisterMsg($WM_HSCROLL, "WM_SCROLL")

while 1
	#cs
	GUICtrlSetData($ButtonNext,$o_doc.body.scrollTop)
	if $o_doc.body.scrollTop=($o_doc.body.scrollHeight-$o_doc.body.clientHeight) then
		setFile($pos+1)
		$pos+=1
	elseif $o_doc.body.scrollTop=0 then
		setFile($pos-1)
		$pos-=1
	endif
	#ce
	if $speaking then
		if _WinAPI_WaitForSingleObject($oTalk.SpeakCompleteEvent,0)<>258 then
			$speaking=false
			if NOT $ReadModeEdit then
				if speakNext()=-1 then
					stopSpeach()
				endif
			endif
		endif
	endif
	sleep(100)
WEnd

Func _getLanguageText($name)
	$text=IniRead($LanguageSettingsIniPath,$globalLanguage,$name,"")
	if $text="" then
		MsgBox(16,"Error","Error reading language File: "&@crlf&$LanguageSettingsIniPath&@crlf&" Searching for: "&$name)
		return "Error"
	else
		return $text
	endif
EndFunc

Func _saveAktState()
	If $SaveFilePos and $Epubpath<>"" then
		$scrollPos=$IE.document.body.scrollTop
		IniWrite($StateIni,"Files",$Epubpath,$pos&"|"&$scrollPos)
	EndIf
EndFunc

Func _changeSaveFilePos()
	if BitAND(GUICtrlRead($CheckBoxSavePosition), $GUI_CHECKED) = $GUI_CHECKED then
		$SaveFilePos=true
	Else
		$SaveFilePos=false
	EndIf
EndFunc

Func Reader()
	$ReadGui = GUICreate(_getLanguageText("GuiReader"), $guiInfo[2], $guiInfo[3]-25, $guiInfo[0], $guiInfo[1],$WS_CAPTION +$WS_SYSMENU+ $WS_SIZEBOX +$WS_MINIMIZEBOX+$WS_MAXIMIZEBOX)
	$ReadGui_Edit=GUICtrlCreateList("",10,200,150,$guiInfo[3]-245,BitOR($WS_BORDER,$WS_HSCROLL,$WS_VSCROLL, $LBS_NOTIFY))
	GUICtrlSetResizing(-1,2+256+32+64)
	$ButtonNext=GUICtrlCreateButton(">",470,10,20,25)
	GUICtrlSetOnEvent(-1,"setFileButtonNext")
	GUICtrlSetResizing(-1,2+768+32)
	$ButtonPrev=GUICtrlCreateButton("<",440,10,20,25)
	GUICtrlSetOnEvent(-1,"setFileButtonPrev")
	GUICtrlSetResizing(-1,2+768+32)
	$ButtonOpen=GUICtrlCreateButton(_getLanguageText("GuiReader1"),330,10,100,25)
	GUICtrlSetOnEvent(-1,"_open")
	GUICtrlSetResizing(-1,2+768+32)
	$ButtonOpen=GUICtrlCreateButton(_getLanguageText("GuiReader2"),500,10,250,25)
	GUICtrlSetOnEvent(-1,"aktCombos")
	GUICtrlSetResizing(-1,2+768+32)
	$ButtonOpen=GUICtrlCreateButton(_getLanguageText("GuiReader3"),760,10,250,25)
	GUICtrlSetOnEvent(-1,"_changeReadModeButton")
	GUICtrlSetResizing(-1,2+768+32)
	$CheckBoxSavePosition=GUICtrlCreateCheckbox(_getLanguageText("GuiReader4"),1025,10,250,25)
	GUICtrlSetOnEvent(-1,"_changeSaveFilePos")
	GUICtrlSetResizing(-1,2+768+32)
	if $SaveFilePos and $SaveFilePos<>"False" then
		GUICtrlSetState(-1,$GUI_CHECKED)
	endif

	GUICtrlCreateLabel(_getLanguageText("GuiSetting6"),1280,10,130,25)
	$LanguageCombo=GUICtrlCreateCombo($globalLanguage,1415,10,100,25)
	GUICtrlSetOnEvent(-1,"_changeLanguage")
	$string=""
	$ar=IniReadSectionNames($LanguageSettingsIniPath)
	for $i=1 to UBound($ar)-1 step 1
		if $ar[$i]<>$globalLanguage then
			if $string<>"" then
				$string&="|"
			endif
			$string&=$ar[$i]
		endif
	next
	if $string<>"" then
		GUICtrlSetData($LanguageCombo,$string)
	endif

	$ButtonPlay=GUICtrlCreateButton(_getLanguageText("GuiReader5"),60,35,80,25)
	GUICtrlSetOnEvent(-1,"speach")
	GUICtrlSetResizing(-1,2+768+32)
	$ButtonPause=GUICtrlCreateButton(_getLanguageText("GuiReader6"),60,65,80,25)
	GUICtrlSetOnEvent(-1,"pauseSpeach")
	GUICtrlSetResizing(-1,2+768+32)
	GUICtrlSetState($ButtonPause,$GUI_DISABLE)
	$ButtonStop=GUICtrlCreateButton(_getLanguageText("GuiReader7"),60,90,80,25)
	GUICtrlSetOnEvent(-1,"stopSpeach")
	GUICtrlSetResizing(-1,2+768+32)
	GUICtrlSetState($ButtonStop,$GUI_DISABLE)
	$ComboVoice=GUICtrlCreateCombo(_getLanguageText("GuiReader8"),10,10,150,20)
	GUICtrlSetOnEvent(-1,"ComboVoiceChangeButton")
	GUICtrlSetResizing(-1,2+768+32)
	$ComboOutput=GUICtrlCreateCombo(_getLanguageText("GuiReader9"),170,10,150,20)
	GUICtrlSetOnEvent(-1,"ComboOutputChangeButton")
	GUICtrlSetResizing(-1,2+768+32)
	GUICtrlCreateLabel(_getLanguageText("GuiReader10"),10,35,50,20)
	GUICtrlSetResizing(-1,2+768+32)
	$VolumeSlider=GUICtrlCreateSlider(10,50,40,80,BitOR($TBS_VERT,$TBS_NOTICKS))
	GUICtrlSetLimit (-1,100,0)
	GUICtrlSetResizing(-1,2+768+32)
	_GUICtrlSlider_SetPos($VolumeSlider,0)
	GUICtrlCreateLabel(_getLanguageText("GuiReader11"),50,118,80,20)
	GUICtrlSetResizing(-1,2+768+32)
	$RateSlider=GUICtrlCreateSlider(10,135,150,25,$TBS_NOTICKS)
	GUICtrlSetLimit (-1,100,-100)
	GUICtrlSetResizing(-1,2+768+32)
	_GUICtrlSlider_SetPos($RateSlider,5)
	GUICtrlCreateLabel(_getLanguageText("GuiReader12"),20,170,80,20)
	GUICtrlSetResizing(-1,2+768+32)
	$ComboSize=GUICtrlCreateCombo("",90,170,40,20)
	$string="6|8|10|12|14|18|20|22|24|26|28|30|32|34|36|38|40|42|44|46|48|50"
	if StringInStr($string,$actSize)=0 then
		$string=$actSize&"|"&$string
	endif
	GUICtrlSetData(-1,$string,$actSize)
	GUICtrlSetOnEvent(-1,"_fontResize")
	GUICtrlSetResizing(-1,2+768+32)
	$ReadEdit = GUICtrlCreateEdit("",165, 40, $guiInfo[2]-195,$guiInfo[3]-85)
	GUICtrlSetResizing(-1,102)
	GUICtrlSetState($ReadEdit,$GUI_HIDE)
	$IE = _IECreateEmbedded()
	$ReadObj = GUICtrlCreateObj($IE,165, 40, $guiInfo[2]-195,$guiInfo[3]-85)
	GUICtrlSetResizing(-1,102)
	_IENavigate($IE, 'about:blank')
	if $guiInfo[4]="47" then
		GUISetState(@SW_MAXIMIZE,$ReadGui)
	endif
	GUISetState(@SW_SHOW)
	$o_doc=_IEDocGetObj($IE)
EndFunc

Func _changeLanguage()
	IniWrite($settingsIniPfad,"General","language",GUICtrlRead($LanguageCombo))
	if GUICtrlRead($LanguageCombo)<>$globalLanguage then
		$globalLanguage=GUICtrlRead($LanguageCombo)
		msgbox(48,_getLanguageText("hint"),_getLanguageText("GuiSetting7"))
	endif
EndFunc

Func _changeReadModeButton()
	_changeReadMode()
EndFunc

Func _changeReadMode($edit=5)
	;_changeReadMode(false)
	if $edit=5 then
		if $ReadModeEdit then
			$ReadModeEdit=false
			GUICtrlSetState($ReadEdit,$GUI_HIDE)
			GUICtrlSetState($ReadObj,$GUI_SHOW)
			GUICtrlSetState($ReadGui_Edit,$GUI_ENABLE)
			GUICtrlSetState($ButtonNext,$GUI_ENABLE)
			GUICtrlSetState($ButtonPrev,$GUI_ENABLE)
		else
			$ReadModeEdit=true
			GUICtrlSetState($ReadObj,$GUI_HIDE)
			GUICtrlSetState($ReadEdit,$GUI_SHOW)
			GUICtrlSetState($ReadGui_Edit,$GUI_DISABLE)
			GUICtrlSetState($ButtonNext,$GUI_DISABLE)
			GUICtrlSetState($ButtonPrev,$GUI_DISABLE)
		endif
	elseif $edit=true then
		$ReadModeEdit=true
		GUICtrlSetState($ReadObj,$GUI_HIDE)
		GUICtrlSetState($ReadEdit,$GUI_SHOW)
		GUICtrlSetState($ReadGui_Edit,$GUI_DISABLE)
		GUICtrlSetState($ButtonNext,$GUI_DISABLE)
		GUICtrlSetState($ButtonPrev,$GUI_DISABLE)
	else
		$ReadModeEdit=false
		GUICtrlSetState($ReadEdit,$GUI_HIDE)
		GUICtrlSetState($ReadObj,$GUI_SHOW)
		GUICtrlSetState($ReadGui_Edit,$GUI_ENABLE)
		GUICtrlSetState($ButtonNext,$GUI_ENABLE)
		GUICtrlSetState($ButtonPrev,$GUI_ENABLE)
	endif
EndFunc

Func _fontResize()
	$text=_IEBodyReadHTML($IE)
	$text=StringRegExpReplace($text,'<DIV style="FONT-SIZE: [0-9]+px">',"",1)
	$text=StringReplace($text,"</div>","",-1)
	$newSize=GUICtrlRead($ComboSize)
	if $actSize<>$newSize then
		if StringIsInt($newSize) then
			_IEBodyWriteHTML($IE,'<div style="font-size:'&$newSize&'px">'&$text&"</div>")
			$actSize=$newSize
		else
			msgbox(48,_getLanguageText("Error"),_getLanguageText("GuiReader13"))
		endif
	EndIf
EndFunc

Func _open()
	$Epubpath=FileOpenDialog(_getLanguageText("chooseEpub"),@DesktopDir,"epub (*.epub)",1,"",$ReadGui)
	_setData($Epubpath)
EndFunc

Func setFileButtonNext()
	if $pos<>UBound($spinesar)-1 then
		setFile($pos+1)
		$pos+=1
		return 1
	endif
	return -1
EndFunc

Func setFileButtonPrev()
	if $pos<>0 then
		setFile($pos-1)
		$pos-=1
	endif
EndFunc

Func aktCombos()
	_GUICtrlComboBox_ResetContent ($ComboVoice)
	_GUICtrlComboBox_ResetContent ($ComboOutput)
	GUICtrlSetData($ComboVoice,_getLanguageText("GuiReader8"))
	GUICtrlSetData($ComboOutput,_getLanguageText("GuiReader9"))
	_GUICtrlComboBox_SetCurSel($ComboVoice,0)
	_GUICtrlComboBox_SetCurSel($ComboOutput,0)
	$voices=""
	Dim $SOTokens = $oTalk.GetVoices('','')
	For $Token In $SOTokens
        $voices&="|"&$Token.GetDescription
	Next
	$voices=StringTrimLeft($voices,1)
	GUICtrlSetData($ComboVoice,$voices)
	$Outputs=""
	Dim $SOTokens = $oTalk.GetAudioOutputs('','')
	For $Token In $SOTokens
        $Outputs&="|"&$Token.GetDescription
	Next
	$Outputs=StringTrimLeft($Outputs,1)
	GUICtrlSetData($ComboOutput,$Outputs)
EndFunc

Func speakNext()
	if setFileButtonNext()<>-1 then
		speach()
	else
		return -1
	endif
EndFunc

Func stopSpeach()
	$oTalk = ObjCreate("SAPI.SpVoice")
	GUICtrlSetData($ButtonPause, _getLanguageText("GuiReader6"))
	$VoiceBreak=false
	$speaking=false
	GUICtrlSetState($ButtonPause,$GUI_DISABLE)
	GUICtrlSetState($ButtonStop,$GUI_DISABLE)
EndFunc

Func pauseSpeach()
	if $VoiceBreak then
		$oTalk.Resume()
		$VoiceBreak=false
		GUICtrlSetData($ButtonPause,_getLanguageText("GuiReader6"))
	else
		$oTalk.Pause()
		$VoiceBreak=true
		GUICtrlSetData($ButtonPause,_getLanguageText("GuiReader14"))
	endif
EndFunc

Func ComboOutputChangeButton()
	ComboOutputChange()
	if $speaking then
		speach()
	endif
EndFunc

Func ComboVoiceChangeButton()
	ComboVoiceChange()
	if $speaking then
		speach()
	endif
EndFunc

Func ComboOutputChange()
	$output=GUICtrlRead($ComboOutput)
	Dim $SOTokens = $oTalk.GetAudioOutputs('','')
	For $Token In $SOTokens
        if $Token.GetDescription=$output then
			$oTalk.AudioOutput=$Token
		endif
	Next
EndFunc

Func ComboVoiceChange()
	$voice=GUICtrlRead($ComboVoice)
	Dim $SOTokens = $oTalk.GetVoices('', '')
	For $Token In $SOTokens
        if $Token.GetDescription=$voice then
			$oTalk.Voice=$Token
		endif
	Next
EndFunc

Func speach()
	if NOT $ReadModeEdit then
		stopSpeach()
		if _IEBodyReadText($IE)<>"" then
			_Say(_IEBodyReadText($IE),_GUICtrlSlider_GetPos($RateSlider)/10)
		endif
		$speaking=true
		GUICtrlSetState($ButtonPause,$GUI_ENABLE)
		GUICtrlSetState($ButtonStop,$GUI_ENABLE)
	else
		stopSpeach()
		if GUICtrlRead($ReadEdit)<>"" then
			_Say(GUICtrlRead($ReadEdit),_GUICtrlSlider_GetPos($RateSlider)/10)
		endif
		$speaking=true
		GUICtrlSetState($ButtonPause,$GUI_ENABLE)
		GUICtrlSetState($ButtonStop,$GUI_ENABLE)
	endif
EndFunc

Func _Say($sText, $iRate = 1, $iVolume = 100)
    $oTalk.Rate = $iRate
    $oTalk.Volume = 100-_GUICtrlSlider_GetPos($VolumeSlider)
	ComboVoiceChange()
	ComboOutputChange()
	$oTalk.Speak($sText,1)
EndFunc

Func setFile($nr=-1,$path="")
	if $nr>-1 and $nr<UBound($spinesar) or $path<>"" then
		$file=""
		if $path<>"" then
			;$ar=StringSplit($path,"#")
			;for $i=1 to UBound($ar)-2 step 1
			;	$file&=$ar[$i]
			;next
			;$path=StringReplace($path,"/","\")
			$file=_ArraySearch($manifestsar,$path,0,0,0,0,1,1)
			$pos=_ArraySearch($spinesar,$manifestsar[$file][0],0,0,0,0,1,0)
			;msgbox(48,"",$file)
		else
			$file=_ArraySearch($manifestsar,$spinesar[$nr],0,0,0,0,1,0)
		endif
		local $drive,$dir,$name,$ext
		_PathSplit ($GlobalReadPath&"\"&StringReplace($manifestsar[$file][1],"%20"," "), $drive,$dir,$name,$ext)
		$resized=false
		if $ext<>".html" then
			if $ext=".xhtml" then
				$path=$drive&$dir&$name&".html"
				$path=StringReplace($path,$GlobalReadPath&"\","")
				FileMove($drive&$dir&$name&$ext,$drive&$dir&$name&".html")
				_IENavigate($IE,"file:///" &$GlobalReadPath&"\"&$path)
				$fileData=FileRead($GlobalReadPath&"\"&$path)
				$ar=stringsplit($path,"\")
				$pfad=$ar[UBound($ar)-1]
				$fileData=StringRegExpReplace($fileData,"<body(.*?)>","<body>",1)
				$fileData=StringRegExpReplace($fileData,"<head(.*?)>","<head>",1)
				$betw=_StringBetween($fileData,"<body>","</body>")
				if not @error then
					if transUmlaute($betw[0],true) then
						_IEBodyWriteHTML($IE,'<div style="font-size:'&GUICtrlRead($ComboSize)&'px">'&transUmlaute($betw[0])&"</div>")
						$resized=true
					endif
				endif
			else
				$fileData=FileRead($GlobalReadPath&"\"&$manifestsar[$file][1])
				$ar=stringsplit($manifestsar[$file][1],"\")
				$pfad=$ar[UBound($ar)-1]
				;$fileData=StringRegExpReplace($fileData,"<body(.*?)>","<body>",1)
				;$fileData=StringRegExpReplace($fileData,"<head(.*?)>","<head>",1)
				;$betw=_StringBetween($fileData,"<body>","</body>")
				;_IEBodyWriteHTML($IE,$betw[0])
				_IEBodyWriteHTML($IE,'<div style="font-size:'&GUICtrlRead($ComboSize)&'px">'&transUmlaute($fileData)&"</div>")
				$resized=true
			endif
		else
			_IENavigate($IE,"file:///" &$GlobalReadPath&"\"&$manifestsar[$file][1])
			$fileData=FileRead($GlobalReadPath&"\"&$manifestsar[$file][1])
			$ar=stringsplit($manifestsar[$file][1],"\")
			$pfad=$ar[UBound($ar)-1]
			$fileData=StringRegExpReplace($fileData,"<body(.*?)>","<body>",1)
			$fileData=StringRegExpReplace($fileData,"<head(.*?)>","<head>",1)
			$betw=_StringBetween($fileData,"<body>","</body>")
			if not @error then
				if transUmlaute($betw[0],true) then
					_IEBodyWriteHTML($IE,'<div style="font-size:'&GUICtrlRead($ComboSize)&'px">'&transUmlaute($betw[0])&"</div>")
					$resized=true
				endif
			endif
		endif
		if NOT $resized then
			_IEBodyWriteHTML($IE,'<div style="font-size:'&GUICtrlRead($ComboSize)&'px">'&_IEBodyReadHTML($IE)&"</div>")
		endif
		;$IE.document.parentWindow.scroll(0, 1)
	endif
EndFunc

Func transUmlaute($sString,$check=false)
	Local $aChars[43-7][2] = [['','&Auml;'], _
                       ['','&Ouml;'], _
                       ['','&Uuml;'], _
                       ['','&auml;'], _
                       ['','&ouml;'], _
                       ['','&uuml;'], _
                       ['','A'], _
                       ['','A'], _
                       ['','A'], _
                       ['','a'], _
                       ['','a'], _
                       ['','a'], _
                       ['','E'], _
                       ['','E'], _
                       ['','E'], _
                       ['','e'], _
                       ['','e'], _
                       ['','e'], _
                       ['','I'], _
                       ['','I'], _
                       ['','I'], _
                       ['','i'], _
                       ['','i'], _
                       ['','i'], _
                       ['','O'], _
                       ['','O'], _
                       ['','O'], _
                       ['','o'], _
                       ['','o'], _
                       ['','o'], _
                       ['','U'], _
                       ['','U'], _
                       ['','U'], _
                       ['','U'], _
                       ['','U'], _
                       ['','U']];, _
                       ;['\_',''], _ ; _
                       ;['\\',''], _ ; \
                       ;['\/',''], _ ; /
                       ;['\.',''], _ ; .
                       ;['\-',''], _ ; -
                       ;['\,',''], _ ; ,
                       ;["\'",'']] ; '

	For $i = 0 To UBound($aChars) - 1 Step 1
		If StringRegExp($sString, $aChars[$i][0]) = 1 Then
			if $check then
				return true
			else
				$sString = StringRegExpReplace($sString, $aChars[$i][0], $aChars[$i][1])
			endif
		endif
	Next
	;ClipPut($sString)
	if $check then
		return false
	endif
	return $sString
EndFunc

Func _setData($pfad)
	if $pfad="" then
		return -1
	endif
	if $FileName<>"" then
		DirRemove (@ScriptDir&"\Data\tempRead\"&$FileName,1)
	endif
	GUICtrlSetData($ReadGui_Edit,"")
	;$ReadGui_Edit
	local $drive,$dir,$name,$ext
	_PathSplit ($pfad, $drive,$dir,$name,$ext)
	$FileName=$name
	_gibXmlData($manifestsar,$spinesar,$pfad,@ScriptDir&"\Data\tempRead\"&$FileName)
	;_ArrayDisplay($spinesar)
	;_ArrayDisplay($manifestsar)
	WinSetTitle($ReadGui,"",_getLanguageText("GuiReader")&" - "&$pfad)
	$toc=_ArraySearch($manifestsar,"toc.ncx",0,0,0,0,1,1)
	if $toc<>-1 then
		;other captures
		$TocFile=FileRead($GlobalReadPath&"\"&$manifestsar[$toc][1])
		;ClipPut($TocFile)
		$navsTmp=_StringBetween($TocFile,"<navPoint","</navPoint>")
		$pagesTmp=_StringBetween($TocFile,"<pageTarget","</pageTarget>")
		;local $navs[UBound($navsTmp)][4]
		;local $pages[UBound($pagesTmp)][4]
		ReDim $ges[UBound($navsTmp)+UBound($pagesTmp)][4]
		for $i=0 to UBound($navsTmp)-1 step 1
			$ges[$i][0]=_StringBetween($navsTmp[$i],'playOrder="','"')[0]
			$ges[$i][1]=_StringBetween($navsTmp[$i],'<text>','</text>')[0]
			_GUICtrlListBox_AddString($ReadGui_Edit,$ges[$i][1])
			$tmp=_StringBetween($navsTmp[$i],'src="','"')[0]
			if StringInStr($tmp,"#") then
				$ar=StringSplit($tmp,"#")
				$ges[$i][2]=$ar[1]
				$ges[$i][3]="#"&$ar[2]
			else
				$ges[$i][2]=$tmp
				$ges[$i][3]=""
			endif
		next
		#cs
		for $i=0 to UBound($pagesTmp)-1 step 1
			$ges[$i][0]=_StringBetween($pagesTmp[$i],'playOrder="','"')[0]
			$ges[$i][1]=_StringBetween($pagesTmp[$i],'<content src="','"/>')[0]
			$tmp=$ges[$i][1]
			if StringInStr($tmp,"#") then
				$ar=StringSplit($tmp,"#")
				$ges[$i][2]=$ar[1]
				$ges[$i][3]=$ar[2]
			else
				$ges[$i][2]=$tmp
				$ges[$i][3]=""
			endif
		next
		#ce
		;_ArrayDisplay($ges)
	else
		;my captures
	endif
	;_ArrayDisplay($navsTmp)
	;_ArrayDisplay($pagesTmp)
	;_ArrayDisplay($manifestsar)
	;_ArrayDisplay($spinesar)
	;_ArrayDisplay($ges)
	setFile(0)
	;_IENavigate($IE,"file:///" &$GlobalReadPath&"\"&$manifestsar[0][1])
	;local $idxList[UBound($spinesar)]
	local $data,$head
	if $toc<>-1 then
		$data=""
		$head=""
		for $i=0 to UBound($spinesar)-1 step 1
			;$idxList[$i]=_ArraySearch($manifestsar,$spinesar[$i],0,0,0,0,1,0)
			$idx=_ArraySearch($manifestsar,$spinesar[$i],0,0,0,0,1,0)
			$fileData=FileRead($GlobalReadPath&"\"&$manifestsar[$idx][1])
			$ar=stringsplit($manifestsar[$idx][1],"\")
			$pfad=$ar[UBound($ar)-1]
			$fileData=StringRegExpReplace($fileData,"<body(.*?)>","<body>",1)
			$fileData=StringRegExpReplace($fileData,"<head(.*?)>","<head>",1)
			$betw=_StringBetween($fileData,"<body>","</body>")
			for $j=0 to ubound($betw)-1 step 1
				$data&='<div style="display:block" id="'&$i&'-body">'&$betw[$j]&'</div>'
			next
			if $head="" then
				$ar=_StringBetween($fileData,"<head>","</head>")
				if $ar<>0 then
					$head=$ar[0]
				endif
			endif
			;if $i<>UBound($spinesar)-1 then
				;$data&='<div style="display:none">'&$pfad&'</div>'
			;	$data&='<div style="display:none" id="'&$i&'">'&$pfad&'</div>'
			;endif
		next
	else
		$data=""
		$head=""
		for $i=0 to UBound($ges)-1 step 1
			;$idxList[$i]=_ArraySearch($manifestsar,$spinesar[$i],0,0,0,0,1,0)
			;$idx=_ArraySearch($manifestsar,$spinesar[$i],0,0,0,0,1,0)
			$fileData=FileRead($GlobalReadPath&"\"&$ges[$i][2])
			;msgbox(48,"",$GlobalReadPath&"\"&$ges[$i][2])
			$ar=stringsplit($ges[$i][2],"\")
			$pfad=$ar[UBound($ar)-1]
			$fileData=StringRegExpReplace($fileData,"<body(.*?)>","<body>",1)
			$fileData=StringRegExpReplace($fileData,"<head(.*?)>","<body>",1)
			$betw=_StringBetween($fileData,"<body>","</body>")
			;msgbox(48,"",$betw[0])
			for $j=0 to ubound($betw)-1 step 1
				$data&='<div style="display:block" id="'&$i&'-body">'&$betw[$j]&'</div>'
			next
			if $head="" then
				$ar=_StringBetween($fileData,"<head>","</head>")
				if $ar<>0 then
					$head=$ar[0]
				endif
			endif
			;if $i<>UBound($ges)-1 then
				;$data&='<div style="display:none">'&$pfad&'</div>'
			;	$data&='<div style="display:none" id="'&$i&'">'&$pfad&'</div>'
			;endif
		next
	endif
	$data2="<html><head>"&$head&"</head><script>"&@crlf
	$data2&='function show(var1){'&@crlf
	$data2&='	if(document.getElementById(var1).style.display == "none"){'&@crlf
	$data2&='		document.getElementById(var1).style.display="block";'&@crlf
	$data2&='	}'&@crlf
	$data2&='	else{'&@crlf
	$data2&='		document.getElementById(var1).style.display = "none";'&@crlf
	$data2&='	}'&@crlf
	$data2&='}'&@crlf
	$data2&='</script><body>'&@crlf
	$data2&=$data&"</body></html>"
	$data=$data2
	;_IEBodyWriteHTML($IE,_IEBodyReadHTML($IE)&$data)
	;_IEDocInsertHTML($IE,$data)
	;ClipPut($data)
	;$data=StringLeft($data,1000)

	;_IENavigate($IE,"file:///" & $GlobalReadPath);_IENavigate($IE, @ScriptDir&"\Aakeson, Kim Fupz - Taeter wie wir\OEBPS\b9783423415538_000017.xhtml")
	;msgbox(48,"",$GlobalReadPath&"\"&$manifestsar[9][1])
	;msgbox(48,"",FileRead($GlobalReadPath&"\"&$manifestsar[9][1]))
	;for $i=0 to UBound($manifestsar)-1 step 1
	;	$data&=FileRead($GlobalReadPath&"\"&$manifestsar[$i][1])
	;next
	;StringReplace($GlobalReadPath&"\"&$manifestsar[$toc][1],"\","/")
	;_IENavigate($IE,"file:///" &$GlobalReadPath&"\"&$manifestsar[$toc][1])
	;_IENavigate($IE,"file:///" &$GlobalReadPath,0)
	;_IEDocWriteHTML($IE,$data)
	;_IENavigate($IE,"#10-body",0)
	;_IENavigate($IE,"file:///" &$GlobalReadPath&"\"&$manifestsar[0][1])
	;for $i=0 to UBound($spinesar)-1 step 1
	;	_IENavigate($IE,"javascript:show('"&$i&"-body');",0)
		;if $i>0 then
		;	_IENavigate($IE,"javascript:show('"&$i-1&"-body');",0)
		;endif
		;sleep(1000)
	;next
	If $SaveFilePos then
		$key=IniRead($StateIni,"Files",$Epubpath,-1)
		if $key<>-1 then
			$array=StringSplit($key,"|",1+2)
			$pos=int($array[0])-1
			setFileButtonNext()
			$IE.document.body.scrollTop=$array[1]
		endif
	EndIf
EndFunc

Func WM_SCROLL($hWnd, $Msg, $wParam, $lParam)
	;msgbox(48,"","")
    If $lParam = GUICtrlGetHandle($VolumeSlider) Then
		$oTalk.Volume = 100-_GUICtrlSlider_GetPos($VolumeSlider)
	elseif $lParam = GUICtrlGetHandle($RateSlider) then
		$oTalk.Rate = (_GUICtrlSlider_GetPos($RateSlider)/10)
    EndIf
    Return $GUI_RUNDEFMSG
EndFunc

Func WM_COMMAND($hWnd, $iMsg, $iwParam, $ilParam)
    #forceref $hWnd, $iMsg
    Local $hWndFrom, $iIDFrom, $iCode, $hWndListBox
    $hWndFrom = $ilParam
    $iIDFrom = BitAND($iwParam, 0xFFFF) ; Low Word
    $iCode = BitShift($iwParam, 16) ; Hi Word
    Switch $hWndFrom
        Case $ReadGui_Edit, GUICtrlGetHandle($ReadGui_Edit)
            Switch $iCode
				Case $LBN_SELCHANGE ; Sent when the selection in a list box has changed
					$x=_GUICtrlListBox_GetCurSel($ReadGui_Edit)
					if $x<>-1 then
						setFile(-1,$ges[$x][2])
					endif
			EndSwitch
		Case $ComboSize, GUICtrlGetHandle($ComboSize)
			;msgbox(48,"",$iCode)
            Switch $iCode
				Case 4
					_fontResize()
            EndSwitch
	EndSwitch
    Return $GUI_RUNDEFMSG
 EndFunc   ;==>WM_COMMAND

Func _gibXmlData(ByRef $manifestAr, ByRef $SpineAr,$path,$MainPath)
	_7ZipProgress(@ScriptDir&"\Data\Tools\7zG.exe",$path, $MainPath, false)
	$path=$MainPath&"\META-INF\container.xml"
	$file=FileOpen($path)
	$content=FileRead($file)
	FileClose($file)
	$sc1=StringSplit($content,'<rootfile full-path="',1)
	if $sc1[0]<2 then
		return -1
	else
		$sc1=StringSplit($sc1[2],'"',1)
		$sc1[1]=StringReplace($sc1[1],"/","\")
		;global Path
		$splittedPath=StringSplit($MainPath&"\"&$sc1[1],"\")
		$GlobalReadPath=""
		for $i=1 to UBound($splittedPath)-3 step 1
			$GlobalReadPath&=$splittedPath[$i]&"\"
		next
		$GlobalReadPath&=$splittedPath[UBound($splittedPath)-2]
		;global path end
		$fileData=FileRead($MainPath&"\"&$sc1[1])
		$fileManifestData=_StringBetween($fileData,"<manifest","</manifest")
		$fileManifestData=_StringBetween($fileManifestData[0],"<item",">")
		local $fileManifestDataArray[UBound($fileManifestData)][3]
		for $i=0 to UBound($fileManifestData)-1 step 1
			$fileManifestDataArray[$i][0]=_StringBetween($fileManifestData[$i],'id="','"')[0]
			$fileManifestDataArray[$i][1]=_StringBetween($fileManifestData[$i],'href="','"')[0]
			$fileManifestDataArray[$i][2]=_StringBetween($fileManifestData[$i],'media-type="','"')[0]
		next
		$fileSpineData=_StringBetween($fileData,"<spine","</spine")
		$fileSpineData=_StringBetween($fileSpineData[0],"<itemref",">")
		for $i=0 to UBound($fileSpineData)-1 step 1
			$fileSpineData[$i]=_StringBetween($fileSpineData[$i],'idref="','"')[0]
		next
		ReDim $manifestAr[UBound($fileManifestDataArray)][3]
		ReDim $SpineAr[UBound($fileSpineData)]
		for $i=0 to UBound($fileManifestDataArray)-1 step 1
			$manifestAr[$i][0]=$fileManifestDataArray[$i][0]
			$manifestAr[$i][1]=$fileManifestDataArray[$i][1]
			$manifestAr[$i][2]=$fileManifestDataArray[$i][2]
		next
		for $i=0 to UBound($fileSpineData)-1 step 1
			$SpineAr[$i]=$fileSpineData[$i]
		next
	endif
EndFunc

Func MainGui_Close()
	$GuiState=WinGetState(WinGetHandle($ReadGui))
	$GuiPos=WinGetPos(WinGetHandle($ReadGui))
	IniWrite($settingsIniPfad,"ReaderGuiSettings","PosX",$GuiPos[0])
	IniWrite($settingsIniPfad,"ReaderGuiSettings","PosY",$GuiPos[1])
	IniWrite($settingsIniPfad,"ReaderGuiSettings","Width",$GuiPos[2])
	IniWrite($settingsIniPfad,"ReaderGuiSettings","Height",$GuiPos[3])
	IniWrite($settingsIniPfad,"ReaderGuiSettings","State",$GuiState)
	IniWrite($settingsIniPfad,"ReaderGuiSettings","Font-Size",$actSize)
	IniWrite($settingsIniPfad,"ReaderSettings","SaveFilesPos",$SaveFilePos)
	_IEQuit($IE)
	DirRemove (@ScriptDir&"\Data\tempRead\"&$FileName,1)
	exit
EndFunc

Func _7ZipProgress($s7ZipEXE, $sSource, $sDestination = @TempDir, $fPack = True, $sPackType = '7z', $iPackLv = 5, $sAdditionalCommands = '', $sFuncToCall = '', $iMinPercentage = 0, $iMaxPercentage = 100, $iUpdateRate = 50)
    Local $sCommand, $iSize, $hTimeBefore, $iPID, $aProcessStats, $iPercentage
    If Not FileExists($s7ZipEXE) Or Not FileExists($sSource) Or $sDestination = '' Then
        Return SetError(1, Default, 0)
    EndIf
    If $iPackLv < 1 Or $iPackLv > 9 Or Not StringRegExp($sPackType, '7z|zip|wim|tar') Then
        Return SetError(2, Default, 0)
    EndIf
    If $sAdditionalCommands <> '' Then
        $sAdditionalCommands = ' ' & $sAdditionalCommands
    EndIf
    If $fPack Then
        $sCommand = ' a "' & $sDestination & '" "' & $sSource & '" -t' & $sPackType & ' -mx=' & $iPackLv & $sAdditionalCommands
    Else
        $sCommand = ' x -o"' & $sDestination & '" "' & $sSource & '"' & $sAdditionalCommands
    EndIf
    If StringInStr(FileGetAttrib($sSource), 'D') Then
        $iSize = DirGetSize($sSource)
    Else
        $iSize = FileGetSize($sSource)
    EndIf
    $hTimeBefore = TimerInit()
    $iPID = Run($s7ZipEXE & ' ' & $sCommand, @TempDir, @SW_HIDE)
    While ProcessExists($iPID)
        $aProcessStats = ProcessGetStats($iPID, 1)
        If $aProcessStats = 0 Then
            SetError(3, Default, 0)
        EndIf
        Sleep($iUpdateRate)
    WEnd
    Return SetExtended(TimerDiff($hTimeBefore), $s7ZipEXE & ' ' & $sCommand)
EndFunc